cocoapods安装

什么是cocoapods

CocoaPods是一个用来帮助我们管理第三方依赖库的工具。它可以解决库与库之间的依赖关系,下载库的源代码,同时通过创建一个Xcode的workspace来将这些第三方库和我们的工程连接起来,供我们开发使用。这么说可能还不是很理解,当我们开发iOS应用时,会经常使用到很多第三方开源类库,比如JSONKit,AFNetWorking等等。可能某个类库又用到其他类库,所以要使用它,必须得另外下载其他类库,而其他类库又用到其他类库,A依赖B,B又依赖C......。总之笔者的意思,手动一个个去下载所需类库十分麻烦。另外一种常见情况是,你项目中用到的类库有更新,你必须得重新下载新版本依赖库,然后一个个重新加入到项目中,费时费力,操作繁琐且容易出错。如果能有什么工具能代替我们手工去解决这些依赖和更新问题,那我们开发效率将如有神助。这就是CocoaPods的作用。
总而言之,使用CocoaPods的目的是让我们能自动化的、集中的、直观的管理第三方开源库。

cocoapods安装

0.升级/安装Ruby环境
CocoaPods 是使用 Ruby 实现的,可以通过 gem 命令来安装。MAC 中一般自带 Ruby 环境,如果没有请参考 Ruby 官方文档来安装 Ruby 环境。也可参考 如何在Mac OS X上安装 Ruby运行环境

  • sudo gem update --system

1.查看现有Ruby镜像源是否为taobao.org

  • $gem sources -l

2.通过以上命令,如果打印的当前Ruby镜像源是https://rubygems.org/ 那么需要使用以下命令移除然后替换为淘宝的镜像源(如果是且仅是https://ruby.taobao.org/ 直接跳转到第4步骤):
你或许会好奇问,为什么需要把https://rubygems.org/替换为https://ruby.taobao.org/,因为https://rubygems.org/在国外,如果我们不替换为淘宝镜像源,那么cocoapods的安装将是非常慢,所以,强烈建议将默认的 RubyGems 源替换为淘宝的 RubyGems 镜像,这样速度要快很多,更多信息可以参考 RubyGems 镜像 - 淘宝网

3.验证新源是否存在,注意,不是i是list的首字母l

  • gem sources -l
    终端显示如下代表替换成功!
    *** CURRENT SOURCES ***
    http://ruby.taobao.org/
    4.安装CocoaPods
    4.1. $sudo gem install cocoapods
    备注:如果苹果系统升级到OS X EL Capitan,以上命令无效,使用如下命令:
  • $sudo gem install -n /usr/local/bin cocoapods
  • sudo xcode-select --switch /Applications/Xcode.app(可有可无)

4.2.将 CocoaPods Specs repository复制到你电脑上~/.cocoapods目录下
备注:"~"代表用户绝对目录的收起状态,展开为:/Users/userName,"."开头的代表是隐藏文件

  • $pod setup

执行以上命令后,需要一点时间来完成,耐心等待。如果安装失败那么 ~/.cocoapods 里面是空的,就需要以下两个命令重新setup。

  • pod repo remove master 
  • pod setup

备注:卸载 CocoaPods 可以使用以下命令:

  • sudo gem uninstall cocoapods

完毕之后这个文件夹大概有 100多M,到这里你已经成功安装了CocoaPods!

cocoapods使用

1.使用search命令搜索类库名,如果能搜到,那么代表该依赖库支持pods的方式集成,反之不能。

  • $ pod search AFNetworking

2.创建Podfile文件,必须要把Podfile创建在项目根目录下(也就是和我们项目的XXX.xcodeproj文件同目录)
$vim Podfile
3.在 Podfile中添加我们需要依赖的库名和版本号,如下

 platform :ios, '8.0'
# Uncomment this line if you're using Swift
 use_frameworks!
pod 'AFNetworking', '~> 3.0'

2.使用install命令安装依赖库
$ pod install
2.1.如果安装依赖库且不希望更新CocoaPods的spec仓库
$ pod --verbose --no-repo-update
执行命令后,控制台会打印如下信息,分别分析依赖、下载依赖、安装依赖库AFNetworking、生成Pods工程、集成我们的项目和Pods工程(也就是生成名为XXX.xcworkspace的文件)。最后会在终端提醒,从现在起,我们该用后缀名为.xcworkspace的文件打开项目。

EricmatoMacBook-Pro:CocoaPodsDemo ericwang$ pod install
        Analyzing dependencies
        Downloading dependencies
        Installing AFNetworking (3.0)
        Generating Pods project
        Integrating client project

        [!] From now on use `VVSPodsDemo.xcworkspace`.

以上是用命令行的方式创建Podfile、编辑Podfile、安装依赖库。还有一种更方便的方式,就是使用CocoaPods插件。CocoaPods的安装和使用非常简单,和其他插件的安装一样,此处不再赘述。

CocoaPods常见问题

Podfile文件过期

问题摘自CocoaPods安装和使用教程

[!] Required version (UAAppReviewManager (from `../`)) not found for `UAAppReviewManager`.
        Available versions: 0.1.6

这里的意思大概是Podfile文件过期,类库有升级,但是Podfile没有更改。$ pod install只会按照Podfile的要求来请求类库,如果类库版本号有变化,那么将获取失败。但是 $ pod update会更新所有的类库,获取最新版本的类库。而且你会发现,如果用了 $ pod update,再用 $ pod install 就成功了。

那你也许会问,什么时候用 $ pod install,什么时候用 $ pod update 呢,我又不知道类库有没有新版本。好吧,那你每次直接用 $ pod update 算了。或者先用 $ pod install,如果不行,再用 $ pod update。

找不到头文件

cocoapods导入一个第三方的库(开源库或者静态/动态库),然后导入这个库的头文件,编译报错,说某个头文件找不到。错误如下:


屏幕快照 2016-04-28 下午2.20.12.png

解决方案:
配置头文件的搜索路径,配置如下:
问题描述:使用cocoapods时,import某个头文件后, 找不到这个头文件中import的其他头文件。

问题原因:这是因为还没设置头文件的目录。

解决办法:在项目的Target的里设置一下,添加cocoapods头文件目录:目录路径直接写:${SRCROOT} ,后边选择recursive 。就可以了。

注意:必须选择recursive ,否则照样报错,recursive是递归查找的意思,如果在当前路径下找不到头文件,会去子路径下继续查找。

注意:是在 User Header Search Paths 里添加,不是上面的 Header Search Paths.

如图:


E1BE8808-66FF-416D-AA93-08BD1709BED0.jpg

文/VV木公子(简书作者)
PS:如非特别说明,所有文章均为原创作品,著作权归作者所有,转载转载请联系作者获得授权,并注明出处,所有打赏均归本人所有!

如果您是iOS开发者,或者对本篇文章感兴趣,请关注本人,后续会更新更多相关文章!敬请期待!

参考文章

CocoaPods安装和使用教程
CocoaPods安装和使用教程以及一些常见问题

posted @ 2016-12-12 10:01  oneSong  阅读(236)  评论(0编辑  收藏